QQ登录

只需一步,快速开始

 找回密码
 立即注册

QQ登录

只需一步,快速开始

查看: 2568|回复: 2

xtrabackup 备份 mysql

[复制链接]

1

主题

3

帖子

11

积分

新手上路

Rank: 1

积分
11
发表于 2016-6-14 17:21:22 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x
#backup.sh  
#!/bin/sh  
#on xtrabackup 2.4.3  
# 第一次执行它的时候它会检查是否有完全备份,否则先创建一个全库备份  
# 当你再次运行它的时候,它会根据脚本中的设定来基于之前的全备或增量备份进行增量备份  

INNOBACKUPEX_PATH=innobackupex  #INNOBACKUPEX的命令  
INNOBACKUPEXFULL=/usr/local/xtrabackup/percona-xtrabackup-2.4.3-Linux-x86_64/bin/$INNOBACKUPEX_PATH  #INNOBACKUPEX的命令路径  

#mysql目标服务器以及用户名和密码  
MYSQL_CMD="--host=localhost --user=root --password=test --port=3306"   

MYSQL_UP=" --user=root --password='test' --port=3306 "  #mysqladmin的用户名和密码  

TMPLOG="/data/xtrabackup/log/innobackupex.$$.log"  

MY_CNF=/etc/my.cnf #mysql的配置文件  

MYSQL=/usr/local/mysql/bin/mysql

#MYSQL_ADMIN=/usr/bin/mysqladmin  

BACKUP_DIR=/data/xtrabackup # 备份的主目录  

FULLBACKUP_DIR=$BACKUP_DIR/full_backup # 全库备份的目录  

INCRBACKUP_DIR=$BACKUP_DIR/increment_backup # 增量备份的目录  

FULLBACKUP_INTERVAL=86400 # 全库备份的间隔周期,时间:秒 86400  

KEEP_FULLBACKUP=1 # 至少保留几个全库备份  1

logfiledate=backup.`date +%Y%m%d%H%M`.txt  

#开始时间  
STARTED_TIME=`date +%s`  



#############################################################################  

# 显示错误并退出  

#############################################################################  

error()  
{  
    echo "$1" 1>&2  
    exit 1  
}  



# 检查执行环境  

if [ ! -x $INNOBACKUPEXFULL ]; then  
  error "$INNOBACKUPEXFULL未安装或未链接到/usr/bin."  
fi  



if [ ! -d $BACKUP_DIR ]; then  
  error "备份目标文件夹BACKUP_DIR不存在."  
fi  



mysql_status=`netstat -nl | awk 'NR>2{if ($4 ~ /.*:3306/) {print "Yes";exit 0}}'`  

if [ "$mysql_status" != "Yes" ];then  
    error "MySQL 没有启动运行."  
fi  





if ! `echo 'exit' | $MYSQL -s $MYSQL_CMD` ; then  
error "提供的数据库用户名或密码不正确!"  
fi  



# 备份的头部信息  

echo "----------------------------"  
echo  
echo "$0: MySQL备份脚本"  
echo "开始于: `date +%F' '%T' '%w`"  
echo  



#新建全备和差异备份的目录  

mkdir -p $FULLBACKUP_DIR  
mkdir -p $INCRBACKUP_DIR  



#查找最新的完全备份  
LATEST_FULL_BACKUP=`find $FULLBACKUP_DIR -mindepth 1 -maxdepth 1 -type d -printf "%P\n" | sort -nr | head -1`  



# 查找最近修改的最新备份时间  

LATEST_FULL_BACKUP_CREATED_TIME=`stat -c %Y $FULLBACKUP_DIR/$LATEST_FULL_BACKUP`  


#如果全备有效进行增量备份否则执行完全备份  
if [ "$LATEST_FULL_BACKUP" -a `expr $LATEST_FULL_BACKUP_CREATED_TIME + $FULLBACKUP_INTERVAL + 5` -ge $STARTED_TIME ] ; then  
    # 如果最新的全备未过期则以最新的全备文件名命名在增量备份目录下新建目录  
    echo -e "完全备份$LATEST_FULL_BACKUP未过期,将根据$LATEST_FULL_BACKUP名字作为增量备份基础目录名"  
    echo "                     "  
    NEW_INCRDIR=$INCRBACKUP_DIR/$LATEST_FULL_BACKUP  
    mkdir -p $NEW_INCRDIR  

    # 查找最新的增量备份是否存在.指定一个备份的路径作为增量备份的基础  
    LATEST_INCR_BACKUP=`find $NEW_INCRDIR -mindepth 1 -maxdepth 1 -type d -printf "%P\n"  | sort -nr | head -1`  
        if [ ! $LATEST_INCR_BACKUP ] ; then  
            INCRBASEDIR=$FULLBACKUP_DIR/$LATEST_FULL_BACKUP  
            echo -e "增量备份将以$INCRBASEDIR作为备份基础目录"  
            echo "                     "  
        else  
            INCRBASEDIR=$INCRBACKUP_DIR/${LATEST_FULL_BACKUP}/${LATEST_INCR_BACKUP}  
            echo -e "增量备份将以$INCRBASEDIR作为备份基础目录"  
            echo "                     "  
        fi  

    echo "使用$INCRBASEDIR作为基础本次增量备份的基础目录."  
    $INNOBACKUPEXFULL --defaults-file=$MY_CNF --use-memory=4G $MYSQL_CMD --incremental $NEW_INCRDIR --incremental-basedir $INCRBASEDIR > $TMPLOG 2>&1  

    #保留一份备份的详细日志  

    cat $TMPLOG>/backup/$logfiledate  

    if [ -z "`tail -1 $TMPLOG | grep 'innobackupex: completed OK!'`" ] ; then  
     echo "$INNOBACKUPEX命令执行失败:"; echo  
     echo -e "---------- $INNOBACKUPEX_PATH错误 ----------"  
     cat $TMPLOG  
     rm -f $TMPLOG  
     exit 1  
    fi  

    THISBACKUP=`awk -- "/Backup created in directory/ { split( \\\$0, p, \"'\" ) ; print p[2] }" $TMPLOG`  
    rm -f $TMPLOG  


    echo -n "数据库成功备份到THISBACKUP"  
    echo  

    # 提示应该保留的备份文件起点  

    LATEST_FULL_BACKUP=`find $FULLBACKUP_DIR -mindepth 1 -maxdepth 1 -type d -printf "%P\n" | sort -nr | head -1`  

    NEW_INCRDIR=$INCRBACKUP_DIR/$LATEST_FULL_BACKUP  

    LATEST_INCR_BACKUP=`find $NEW_INCRDIR -mindepth 1 -maxdepth 1 -type d -printf "%P\n"  | sort -nr | head -1`  

    RES_FULL_BACKUP=${FULLBACKUP_DIR}/${LATEST_FULL_BACKUP}  

    RES_INCRE_BACKUP=`dirname ${INCRBACKUP_DIR}/${LATEST_FULL_BACKUP}/${LATEST_INCR_BACKUP}`  

    echo  
    echo -e '\e[31m NOTE:---------------------------------------------------------------------------------.\e[m' #红色  
    echo -e "必须保留$KEEP_FULLBACKUP份全备即全备${RES_FULL_BACKUP}和${RES_INCRE_BACKUP}目录中所有增量备份."  
    echo -e '\e[31m NOTE:---------------------------------------------------------------------------------.\e[m' #红色  
    echo  



else  
    echo  "*********************************"  
    echo -e "正在执行全新的完全备份...请稍等..."  
    echo  "*********************************"  
    $INNOBACKUPEXFULL --defaults-file=$MY_CNF  --use-memory=4G  $MYSQL_CMD $FULLBACKUP_DIR > $TMPLOG 2>&1   
    #保留一份备份的详细日志  

    cat $TMPLOG>/backup/$logfiledate  


    if [ -z "`tail -1 $TMPLOG | grep 'innobackupex: completed OK!'`" ] ; then  
     echo "$INNOBACKUPEX命令执行失败:"; echo  
     echo -e "---------- $INNOBACKUPEX_PATH错误 ----------"  
     cat $TMPLOG  
     rm -f $TMPLOG  
     exit 1  
    fi  


    THISBACKUP=`awk -- "/Backup created in directory/ { split( \\\$0, p, \"'\" ) ; print p[2] }" $TMPLOG`  
    rm -f $TMPLOG  

    echo -n "数据库成功备份到THISBACKUP"  
    echo  

    # 提示应该保留的备份文件起点  

    LATEST_FULL_BACKUP=`find $FULLBACKUP_DIR -mindepth 1 -maxdepth 1 -type d -printf "%P\n" | sort -nr | head -1`  

    RES_FULL_BACKUP=${FULLBACKUP_DIR}/${LATEST_FULL_BACKUP}  

    echo  
    echo -e '\e[31m NOTE:---------------------------------------------------------------------------------.\e[m' #红色  
    echo -e "无增量备份,必须保留$KEEP_FULLBACKUP份全备即全备${RES_FULL_BACKUP}."  
    echo -e '\e[31m NOTE:---------------------------------------------------------------------------------.\e[m' #红色  
    echo  

fi  






#删除过期的全备  

echo -e "find expire backup file...........waiting........."  
echo -e "寻找过期的全备文件并删除">>/backup/$logfiledate  
for efile in $(/usr/bin/find $FULLBACKUP_DIR/ -mtime +6)  
do  
    if [ -d ${efile} ]; then  
    rm -rf "${efile}"  
    echo -e "删除过期全备文件{efile}" >>/backup/$logfiledate  
    elif [ -f ${efile} ]; then  
    rm -rf "${efile}"  
    echo -e "删除过期全备文件{efile}" >>/backup/$logfiledate  
    fi;  

done  

if [ $? -eq "0" ];then  
   echo  
   echo -e "未找到可以删除的过期全备文件"  
fi  



echo  
echo "完成于: `date +%F' '%T' '%w`"  
exit 0  

转:http://blog.csdn.net/yangzhawen/article/details/44857097

642

主题

798

帖子

1万

积分

管理员

Rank: 9Rank: 9Rank: 9

积分
10831
发表于 2016-6-14 18:00:32 | 显示全部楼层
发代码请使用编辑器的代码工具,防止出现表情
招募核心会员担任PHP-Z版主和管理员,共同管理论坛和群组,有意者在论坛发消息联系我

1

主题

26

帖子

462

积分

新手上路

Rank: 1

积分
462
发表于 2016-7-14 22:54:46 | 显示全部楼层
支持贴主,帮助工作的好程序
     
    战略合作|联系方式|广告赞助|商务合作|手机版|小黑屋|( 京ICP备14036609号-6 )

GMT+8, 2017-8-19 09:42

© 2013-2017 Powered by Discuz! X3.3. 本站由 又拍云 提供 CDN 图片存储服务

快速回复 返回顶部 返回列表